#pragma once

#include <ws2tcpip.h>

#if defined(WIN32)
#include <wspiapi.h>
#endif

/*
function getnameinfo is not found in Ws2_32.dll on windows 2000
When including the Ws2tcpip.h file you also have to include the Wspiapi.h file.
When Wspiapi.h include is added, the getnameinfo function is defined to 
the WspiapiGetNameInfo inline function in the Wspiapi.h file. At runtime, 
the WspiapiGetNameInfo function is implemented in such a way that if the 
Ws2_32.dll or the Wship6.dll (the file containing getnameinfo in the IPv6 
Technology Preview for Windows 2000) does not include getnameinfo, then a 
version of getnameinfo is implemented inline based on code in the Wspiapi.h 
header file. This inline code will be used on older Windows platforms that 
do not natively support the getnameinfo function.
*/

#include <assert.h>

#include <stdlib.h>

#include <list>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <sstream>
#include <fstream>

#include <algorithm>
#include <iomanip>

#include <ctype.h>
#include <string.h>
#include <time.h>

#if defined(WIN32) 
  #pragma comment ( lib, "winmm.lib" )
  #pragma comment ( lib, "urlmon.lib" )
  #pragma comment ( lib, "crypt32.lib" )
#endif

// ares
#ifdef WIN32
  #if defined(_DEBUG)
    #pragma comment ( lib, "areslibd.lib" )
  #elif defined(NDEBUG)
    #pragma comment ( lib, "areslib.lib" )
  #endif
#endif

// libcurl
#ifdef WIN32
  #if defined(_DEBUG)
    #pragma comment ( lib, "libcurld.lib" )
  #elif defined(NDEBUG)
    #pragma comment ( lib, "libcurl.lib" )
  #endif
#endif

// openssl
#if defined(WIN32)
  #if defined(_DEBUG)
    #pragma comment ( lib, "libeay32d.lib" )
    #pragma comment ( lib, "ssleay32d.lib" )
  #elif defined(NDEBUG)
    #pragma comment ( lib, "libeay32.lib" )
    #pragma comment ( lib, "ssleay32.lib" )
  #endif
#endif
    
// zlib
#if !defined(LIBHTTP_SKIP_ZLIB)
  #if defined(WIN32)
    #if defined(_DEBUG)
      #pragma comment ( lib, "zlib1d.lib" )
    #elif defined(NDEBUG)
      #pragma comment ( lib, "zlib1.lib" )
    #endif
  #endif
#endif

