#ifndef _TESTDIGESTUPLOAD_CURLTEST_H_
#define _TESTDIGESTUPLOAD_CURLTEST_H_

class BaseUpload
{
public:
  BaseUpload ( std::istream &istream ) : m_istream ( istream ), m_size ( 0 ), m_fileName ( L"" ), m_emptyUpload ( false ), m_IsInitialized ( true ) {}
  virtual ~BaseUpload ( )  { }

  virtual size_t Read ( char *data, size_t size );

  virtual int Size()  { return m_size; }
  virtual const std::wstring &FileName() { return m_fileName; };

protected:
  std::istream                     &m_istream;
  bool                              m_IsInitialized;
  int                               m_size;
  std::wstring                      m_fileName;
  bool                              m_emptyUpload;
};

class CFileUpload : public BaseUpload
{
public:
  CFileUpload ( const std::wstring &localPath );
  virtual ~CFileUpload ();

private:
  std::ifstream                     m_ifstream;
};

int testDigestReadCallback ( char *URL );
int testDigest (char *URL);


#endif